--  E:\151CPROJ\CALCAL.vhd
--  VHDL code created by Xilinx's StateCAD 5.03
--  Mon Mar 15 13:35:36 2004

--  This VHDL code (for use with Xilinx XST) was generated using: 
--  one-hot state assignment with boolean code format.
--  Minimization is enabled,  implied else is enabled, 
--  and outputs are speed optimized.

LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY SHELL_CALCAL IS
	PORT (CLK,hit0,hit1,RESET: IN std_logic;
		countsignal : OUT std_logic);
END;

ARCHITECTURE BEHAVIOR OF SHELL_CALCAL IS
--	State variables for machine sreg
	SIGNAL STATE0, next_STATE0, STATE1, next_STATE1, STATE2, next_STATE2 : 
		std_logic;
	SIGNAL next_countsignal : std_logic;
BEGIN
	PROCESS (CLK, next_STATE0, next_STATE1, next_STATE2, next_countsignal)
	BEGIN
		IF CLK='1' AND CLK'event THEN
			STATE0 <= next_STATE0;
			STATE1 <= next_STATE1;
			STATE2 <= next_STATE2;
			countsignal <= next_countsignal;
		END IF;
	END PROCESS;

	PROCESS (hit0,hit1,RESET,STATE0,STATE1,STATE2)
	BEGIN

		IF (( hit0='0' AND  (STATE0='1')) OR ( hit1='0' AND  (STATE0='1')) OR ( 
			hit0='0' AND hit1='0' AND  (STATE2='1')) OR ( RESET='0' )) THEN 
			next_STATE0<='1';
		ELSE next_STATE0<='0';
		END IF;

		IF (( RESET='1' AND hit0='1' AND hit1='1' AND  (STATE0='1'))) THEN 
			next_STATE1<='1';
		ELSE next_STATE1<='0';
		END IF;

		IF (( RESET='1' AND  (STATE1='1')) OR ( hit1='1' AND RESET='1' AND  (
			STATE2='1')) OR ( RESET='1' AND hit0='1' AND  (STATE2='1'))) THEN 
			next_STATE2<='1';
		ELSE next_STATE2<='0';
		END IF;


		IF (( RESET='1' AND hit0='1' AND hit1='1' AND  (STATE0='1'))) THEN 
			next_countsignal<='1';
		ELSE next_countsignal<='0';
		END IF;
	END PROCESS;
END BEHAVIOR;

LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY CALCAL IS
	PORT (hit : IN std_logic_vector (1 DOWNTO 0);
		CLK,RESET: IN std_logic;
		countsignal : OUT std_logic);
END;

ARCHITECTURE BEHAVIOR OF CALCAL IS
	COMPONENT SHELL_CALCAL
		PORT (CLK,hit0,hit1,RESET: IN std_logic;
			countsignal : OUT std_logic);
	END COMPONENT;
BEGIN
	SHELL1_CALCAL : SHELL_CALCAL PORT MAP (CLK=>CLK,hit0=>hit(0),hit1=>hit(1),
		RESET=>RESET,countsignal=>countsignal);
END BEHAVIOR;
