library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity fbit1time is
    Port ( continue : in std_logic;
	 	     stopaddr: in std_logic_vector(18 downto 0); 
			  startaddr: in std_logic_vector(18 downto 0); 
			  resetn : in std_logic;
			  CLK: in std_logic;
			  done : out std_logic; 
			  count: out std_logic_vector(1 downto 0);
			  ReadAddr: out std_logic_vector(18 downto 0));
end fbit1time;

architecture Behavioral of fbit1time is
signal datatime: std_logic_vector(1 downto 0);
signal curaddress: std_logic_vector(18 downto 0);
signal fin: std_logic;

begin
	process(CLK, continue, resetn)--,datatime, curaddress)
	begin

		if (resetn = '0') then
			datatime<="11";
			curaddress<=startaddr;
			fin<='0';
		elsif (CLK='1' AND CLK'event) then
	  		if  (curaddress > stopaddr+2) then
				fin<='1';
			elsif (datatime = "11" and curaddress = stopaddr+2) then
				fin<='1';
			ELSIF (continue='1') THEN
				if datatime = "11" then
					if (curaddress = stopaddr+2) then
						fin<='1';
					else
						datatime <="00";
						fin<='0';
					end if;
					curaddress<=curaddress+2;
				else
					datatime<= datatime+1;
					fin<='0';
				end if;			
			else
				fin<='0';	
			end if;	
		end if;
		ReadAddr<=curaddress-2;
		count<=datatime;
		done <= fin;
	end process; 

end Behavioral;
