-- Vhdl model created from schematic maintop.sch - Mon Mar 22 06:59:05 2004

LIBRARY ieee;
LIBRARY UNISIM;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
USE UNISIM.Vcomponents.ALL;

ENTITY maintop IS
   PORT ( button1	:	IN	STD_LOGIC; 
          button2	:	IN	STD_LOGIC; 
          button3	:	IN	STD_LOGIC; 
          button4	:	IN	STD_LOGIC; 
          clk	:	IN	STD_LOGIC; 
          ppdata	:	IN	STD_LOGIC_VECTOR (7 DOWNTO 0); 
          resetn	:	IN	STD_LOGIC; 
          startgame	:	IN	STD_LOGIC; 
          RAMDACD	:	OUT	STD_LOGIC_VECTOR (7 DOWNTO 0); 
          RDn	:	OUT	STD_LOGIC; 
          RS	:	OUT	STD_LOGIC_VECTOR (2 DOWNTO 0); 
          WRn	:	OUT	STD_LOGIC; 
          blankn	:	OUT	STD_LOGIC; 
          done	:	OUT	STD_LOGIC; 
          f	:	OUT	STD_LOGIC_VECTOR (1 DOWNTO 0); 
          gdone	:	OUT	STD_LOGIC; 
          hsync	:	OUT	STD_LOGIC; 
          laddr	:	OUT	STD_LOGIC_VECTOR (18 DOWNTO 0); 
          lcen	:	OUT	STD_LOGIC; 
          loen	:	OUT	STD_LOGIC; 
          lwen	:	OUT	STD_LOGIC; 
          pixel	:	OUT	STD_LOGIC_VECTOR (7 DOWNTO 0); 
          pixelclk	:	OUT	STD_LOGIC; 
          ppp	:	OUT	STD_LOGIC_VECTOR (7 DOWNTO 0); 
          ppstatus	:	OUT	STD_LOGIC_VECTOR (6 DOWNTO 3); 
          ready	:	OUT	STD_LOGIC; 
          rramce	:	OUT	STD_LOGIC; 
          triste	:	OUT	STD_LOGIC; 
          vsync	:	OUT	STD_LOGIC; 
          ldata	:	INOUT	STD_LOGIC_VECTOR (15 DOWNTO 0));

end maintop;

ARCHITECTURE SCHEMATIC OF maintop IS
   SIGNAL XLXN_34	:	STD_LOGIC;
   SIGNAL XLXN_37	:	STD_LOGIC_VECTOR (18 DOWNTO 0);
   SIGNAL XLXN_38	:	STD_LOGIC_VECTOR (18 DOWNTO 0);
   SIGNAL XLXN_63	:	STD_LOGIC_VECTOR (119 DOWNTO 0);
   SIGNAL XLXN_69	:	STD_LOGIC;
   SIGNAL XLXN_70	:	STD_LOGIC;
   SIGNAL XLXN_71	:	STD_LOGIC;
   SIGNAL XLXN_72	:	STD_LOGIC;
   SIGNAL XLXN_73	:	STD_LOGIC;
   SIGNAL XLXN_74	:	STD_LOGIC;
   SIGNAL XLXN_75	:	STD_LOGIC;
   SIGNAL XLXN_76	:	STD_LOGIC;
   SIGNAL XLXN_77	:	STD_LOGIC;
   SIGNAL XLXN_79	:	STD_LOGIC;
   SIGNAL XLXN_80	:	STD_LOGIC;
   SIGNAL XLXN_83	:	STD_LOGIC;
   SIGNAL XLXN_85	:	STD_LOGIC;
   SIGNAL XLXN_86	:	STD_LOGIC;
   SIGNAL bclk	:	STD_LOGIC;
   SIGNAL done_DUMMY	:	STD_LOGIC;
   SIGNAL f_DUMMY	:	STD_LOGIC_VECTOR (1 DOWNTO 0);
   SIGNAL gdone_DUMMY	:	STD_LOGIC;
   SIGNAL hit0	:	STD_LOGIC_VECTOR (1 DOWNTO 0);
   SIGNAL hit1	:	STD_LOGIC_VECTOR (1 DOWNTO 0);
   SIGNAL hit2	:	STD_LOGIC_VECTOR (1 DOWNTO 0);
   SIGNAL hit3	:	STD_LOGIC_VECTOR (1 DOWNTO 0);
   SIGNAL pattern	:	STD_LOGIC_VECTOR (3 DOWNTO 0);
   SIGNAL read	:	STD_LOGIC;
   SIGNAL readdone	:	STD_LOGIC;
   SIGNAL resetnn	:	STD_LOGIC;
   SIGNAL vsync_DUMMY	:	STD_LOGIC;

   ATTRIBUTE fpga_dont_touch : STRING ;
   ATTRIBUTE fpga_dont_touch OF XLXI_6 : LABEL IS "true";
   ATTRIBUTE fpga_dont_touch OF XLXI_32 : LABEL IS "true";
   ATTRIBUTE fpga_dont_touch OF XLXI_25 : LABEL IS "true";
   ATTRIBUTE fpga_dont_touch OF XLXI_24 : LABEL IS "true";
   ATTRIBUTE fpga_dont_touch OF XLXI_23 : LABEL IS "true";
   ATTRIBUTE fpga_dont_touch OF XLXI_8 : LABEL IS "true";
   ATTRIBUTE fpga_dont_touch OF XLXI_7 : LABEL IS "true";
   ATTRIBUTE fpga_dont_touch OF XLXI_22 : LABEL IS "true";
   ATTRIBUTE fpga_dont_touch OF XLXI_21 : LABEL IS "true";
   ATTRIBUTE fpga_dont_touch OF XLXI_20 : LABEL IS "true";
   ATTRIBUTE fpga_dont_touch OF XLXI_31 : LABEL IS "true";

   COMPONENT buttonsm
      PORT ( CLK	:	IN	STD_LOGIC; 
             buttonin	:	IN	STD_LOGIC; 
             RESET	:	IN	STD_LOGIC; 
             bsignal	:	OUT	STD_LOGIC);
   END COMPONENT;

   COMPONENT calgrade
      PORT ( slowclk	:	IN	STD_LOGIC; 
             resetn	:	IN	STD_LOGIC; 
             done	:	IN	STD_LOGIC; 
             hit0	:	IN	STD_LOGIC_VECTOR (1 DOWNTO 0); 
             hit1	:	IN	STD_LOGIC_VECTOR (1 DOWNTO 0); 
             hit2	:	IN	STD_LOGIC_VECTOR (1 DOWNTO 0); 
             hit3	:	IN	STD_LOGIC_VECTOR (1 DOWNTO 0); 
             gdone	:	OUT	STD_LOGIC; 
             fgrade	:	OUT	STD_LOGIC_VECTOR (1 DOWNTO 0); 
             gout	:	OUT	STD_LOGIC_VECTOR (7 DOWNTO 0));
   END COMPONENT;

   COMPONENT constaddr
      PORT ( startaddr	:	OUT	STD_LOGIC_VECTOR (18 DOWNTO 0); 
             stopaddr	:	OUT	STD_LOGIC_VECTOR (18 DOWNTO 0));
   END COMPONENT;

   COMPONENT memin
      PORT ( ppdata	:	IN	STD_LOGIC_VECTOR (7 DOWNTO 0); 
             clk	:	IN	STD_LOGIC; 
             resetn	:	IN	STD_LOGIC; 
             stopaddr	:	IN	STD_LOGIC_VECTOR (18 DOWNTO 0); 
             startaddr	:	IN	STD_LOGIC_VECTOR (18 DOWNTO 0); 
             IssueRead	:	IN	STD_LOGIC; 
             lcen	:	OUT	STD_LOGIC; 
             loen	:	OUT	STD_LOGIC; 
             lwen	:	OUT	STD_LOGIC; 
             laddr	:	OUT	STD_LOGIC_VECTOR (18 DOWNTO 0); 
             ppstatus	:	OUT	STD_LOGIC_VECTOR (6 DOWNTO 3); 
             readdone	:	OUT	STD_LOGIC; 
             outdata	:	OUT	STD_LOGIC_VECTOR (3 DOWNTO 0); 
             done	:	OUT	STD_LOGIC; 
             ldata	:	INOUT	STD_LOGIC_VECTOR (15 DOWNTO 0));
   END COMPONENT;

   COMPONENT sloclk
      PORT ( clkin	:	IN	STD_LOGIC; 
             clkout	:	OUT	STD_LOGIC);
   END COMPONENT;

   COMPONENT slowclkforbutton
      PORT ( clkin	:	IN	STD_LOGIC; 
             clkout	:	OUT	STD_LOGIC);
   END COMPONENT;

   COMPONENT top
      PORT ( fromvga	:	IN	STD_LOGIC; 
             clk	:	IN	STD_LOGIC; 
             resetn	:	IN	STD_LOGIC; 
             startgame	:	IN	STD_LOGIC; 
             donefrommem	:	IN	STD_LOGIC; 
             readdone	:	IN	STD_LOGIC; 
             button1	:	IN	STD_LOGIC; 
             button2	:	IN	STD_LOGIC; 
             button3	:	IN	STD_LOGIC; 
             button4	:	IN	STD_LOGIC; 
             pattern1	:	IN	STD_LOGIC; 
             pattern2	:	IN	STD_LOGIC; 
             pattern3	:	IN	STD_LOGIC; 
             pattern4	:	IN	STD_LOGIC; 
             readmem	:	OUT	STD_LOGIC; 
             ready	:	OUT	STD_LOGIC; 
             hit1	:	OUT	STD_LOGIC_VECTOR (1 DOWNTO 0); 
             hit2	:	OUT	STD_LOGIC_VECTOR (1 DOWNTO 0); 
             hit3	:	OUT	STD_LOGIC_VECTOR (1 DOWNTO 0); 
             hit4	:	OUT	STD_LOGIC_VECTOR (1 DOWNTO 0); 
             rows	:	OUT	STD_LOGIC_VECTOR (119 DOWNTO 0));
   END COMPONENT;

   COMPONENT vgatop
      PORT ( clk	:	IN	STD_LOGIC; 
             rstn	:	IN	STD_LOGIC; 
             sdone	:	IN	STD_LOGIC; 
             grade	:	IN	STD_LOGIC_VECTOR (1 DOWNTO 0); 
             hit4	:	IN	STD_LOGIC_VECTOR (1 DOWNTO 0); 
             hit3	:	IN	STD_LOGIC_VECTOR (1 DOWNTO 0); 
             hit2	:	IN	STD_LOGIC_VECTOR (1 DOWNTO 0); 
             hit1	:	IN	STD_LOGIC_VECTOR (1 DOWNTO 0); 
             inin	:	IN	STD_LOGIC_VECTOR (119 DOWNTO 0); 
             blankn	:	OUT	STD_LOGIC; 
             pixel	:	OUT	STD_LOGIC_VECTOR (7 DOWNTO 0); 
             rramce	:	OUT	STD_LOGIC; 
             triste	:	OUT	STD_LOGIC; 
             vsync	:	OUT	STD_LOGIC; 
             hsync	:	OUT	STD_LOGIC; 
             WRn	:	OUT	STD_LOGIC; 
             RDn	:	OUT	STD_LOGIC; 
             pixelclk	:	OUT	STD_LOGIC; 
             RAMDACD	:	OUT	STD_LOGIC_VECTOR (7 DOWNTO 0); 
             RS	:	OUT	STD_LOGIC_VECTOR (2 DOWNTO 0));
   END COMPONENT;

BEGIN
   done <= done_DUMMY;
   f <= f_DUMMY;
   gdone <= gdone_DUMMY;
   vsync <= vsync_DUMMY;

   XLXI_6 : BUFG
      PORT MAP (I=>XLXN_34, O=>bclk);

   XLXI_30 : buttonsm
      PORT MAP (CLK=>XLXN_80, buttonin=>XLXN_85, RESET=>resetnn,
      bsignal=>XLXN_83);

   XLXI_28 : buttonsm
      PORT MAP (CLK=>XLXN_80, buttonin=>XLXN_74, RESET=>resetnn,
      bsignal=>XLXN_77);

   XLXI_27 : buttonsm
      PORT MAP (CLK=>XLXN_80, buttonin=>XLXN_73, RESET=>resetnn,
      bsignal=>XLXN_76);

   XLXI_26 : buttonsm
      PORT MAP (CLK=>XLXN_80, buttonin=>XLXN_72, RESET=>resetnn,
      bsignal=>XLXN_75);

   XLXI_34 : calgrade
      PORT MAP (slowclk=>XLXN_79, resetn=>resetnn, done=>done_DUMMY,
      hit0(1)=>hit0(1), hit0(0)=>hit0(0), hit1(1)=>hit1(1), hit1(0)=>hit1(0),
      hit2(1)=>hit2(1), hit2(0)=>hit2(0), hit3(1)=>hit3(1), hit3(0)=>hit3(0),
      gdone=>gdone_DUMMY, fgrade(1)=>f_DUMMY(1), fgrade(0)=>f_DUMMY(0),
      gout(7)=>ppp(7), gout(6)=>ppp(6), gout(5)=>ppp(5), gout(4)=>ppp(4),
      gout(3)=>ppp(3), gout(2)=>ppp(2), gout(1)=>ppp(1), gout(0)=>ppp(0));

   XLXI_10 : constaddr
      PORT MAP (startaddr(18)=>XLXN_37(18), startaddr(17)=>XLXN_37(17),
      startaddr(16)=>XLXN_37(16), startaddr(15)=>XLXN_37(15),
      startaddr(14)=>XLXN_37(14), startaddr(13)=>XLXN_37(13),
      startaddr(12)=>XLXN_37(12), startaddr(11)=>XLXN_37(11),
      startaddr(10)=>XLXN_37(10), startaddr(9)=>XLXN_37(9),
      startaddr(8)=>XLXN_37(8), startaddr(7)=>XLXN_37(7),
      startaddr(6)=>XLXN_37(6), startaddr(5)=>XLXN_37(5),
      startaddr(4)=>XLXN_37(4), startaddr(3)=>XLXN_37(3),
      startaddr(2)=>XLXN_37(2), startaddr(1)=>XLXN_37(1),
      startaddr(0)=>XLXN_37(0), stopaddr(18)=>XLXN_38(18),
      stopaddr(17)=>XLXN_38(17), stopaddr(16)=>XLXN_38(16),
      stopaddr(15)=>XLXN_38(15), stopaddr(14)=>XLXN_38(14),
      stopaddr(13)=>XLXN_38(13), stopaddr(12)=>XLXN_38(12),
      stopaddr(11)=>XLXN_38(11), stopaddr(10)=>XLXN_38(10),
      stopaddr(9)=>XLXN_38(9), stopaddr(8)=>XLXN_38(8),
      stopaddr(7)=>XLXN_38(7), stopaddr(6)=>XLXN_38(6),
      stopaddr(5)=>XLXN_38(5), stopaddr(4)=>XLXN_38(4),
      stopaddr(3)=>XLXN_38(3), stopaddr(2)=>XLXN_38(2),
      stopaddr(1)=>XLXN_38(1), stopaddr(0)=>XLXN_38(0));

   XLXI_32 : IBUF
      PORT MAP (I=>button4, O=>XLXN_86);

   XLXI_25 : IBUF
      PORT MAP (I=>button3, O=>XLXN_70);

   XLXI_24 : IBUF
      PORT MAP (I=>button2, O=>XLXN_69);

   XLXI_23 : IBUF
      PORT MAP (I=>button1, O=>XLXN_71);

   XLXI_8 : IBUF
      PORT MAP (I=>resetn, O=>resetnn);

   XLXI_7 : IBUF
      PORT MAP (I=>clk, O=>XLXN_34);

   XLXI_22 : INV
      PORT MAP (I=>XLXN_70, O=>XLXN_74);

   XLXI_21 : INV
      PORT MAP (I=>XLXN_69, O=>XLXN_73);

   XLXI_20 : INV
      PORT MAP (I=>XLXN_71, O=>XLXN_72);

   XLXI_31 : INV
      PORT MAP (I=>XLXN_86, O=>XLXN_85);

   XLXI_1 : memin
      PORT MAP (ppdata(7)=>ppdata(7), ppdata(6)=>ppdata(6),
      ppdata(5)=>ppdata(5), ppdata(4)=>ppdata(4), ppdata(3)=>ppdata(3),
      ppdata(2)=>ppdata(2), ppdata(1)=>ppdata(1), ppdata(0)=>ppdata(0),
      clk=>bclk, resetn=>resetnn, stopaddr(18)=>XLXN_38(18),
      stopaddr(17)=>XLXN_38(17), stopaddr(16)=>XLXN_38(16),
      stopaddr(15)=>XLXN_38(15), stopaddr(14)=>XLXN_38(14),
      stopaddr(13)=>XLXN_38(13), stopaddr(12)=>XLXN_38(12),
      stopaddr(11)=>XLXN_38(11), stopaddr(10)=>XLXN_38(10),
      stopaddr(9)=>XLXN_38(9), stopaddr(8)=>XLXN_38(8),
      stopaddr(7)=>XLXN_38(7), stopaddr(6)=>XLXN_38(6),
      stopaddr(5)=>XLXN_38(5), stopaddr(4)=>XLXN_38(4),
      stopaddr(3)=>XLXN_38(3), stopaddr(2)=>XLXN_38(2),
      stopaddr(1)=>XLXN_38(1), stopaddr(0)=>XLXN_38(0),
      startaddr(18)=>XLXN_37(18), startaddr(17)=>XLXN_37(17),
      startaddr(16)=>XLXN_37(16), startaddr(15)=>XLXN_37(15),
      startaddr(14)=>XLXN_37(14), startaddr(13)=>XLXN_37(13),
      startaddr(12)=>XLXN_37(12), startaddr(11)=>XLXN_37(11),
      startaddr(10)=>XLXN_37(10), startaddr(9)=>XLXN_37(9),
      startaddr(8)=>XLXN_37(8), startaddr(7)=>XLXN_37(7),
      startaddr(6)=>XLXN_37(6), startaddr(5)=>XLXN_37(5),
      startaddr(4)=>XLXN_37(4), startaddr(3)=>XLXN_37(3),
      startaddr(2)=>XLXN_37(2), startaddr(1)=>XLXN_37(1),
      startaddr(0)=>XLXN_37(0), IssueRead=>read, lcen=>lcen, loen=>loen,
      lwen=>lwen, laddr(18)=>laddr(18), laddr(17)=>laddr(17),
      laddr(16)=>laddr(16), laddr(15)=>laddr(15), laddr(14)=>laddr(14),
      laddr(13)=>laddr(13), laddr(12)=>laddr(12), laddr(11)=>laddr(11),
      laddr(10)=>laddr(10), laddr(9)=>laddr(9), laddr(8)=>laddr(8),
      laddr(7)=>laddr(7), laddr(6)=>laddr(6), laddr(5)=>laddr(5),
      laddr(4)=>laddr(4), laddr(3)=>laddr(3), laddr(2)=>laddr(2),
      laddr(1)=>laddr(1), laddr(0)=>laddr(0), ppstatus(6)=>ppstatus(6),
      ppstatus(5)=>ppstatus(5), ppstatus(4)=>ppstatus(4),
      ppstatus(3)=>ppstatus(3), readdone=>readdone, outdata(3)=>pattern(3),
      outdata(2)=>pattern(2), outdata(1)=>pattern(1), outdata(0)=>pattern(0),
      done=>done_DUMMY, ldata(15)=>ldata(15), ldata(14)=>ldata(14),
      ldata(13)=>ldata(13), ldata(12)=>ldata(12), ldata(11)=>ldata(11),
      ldata(10)=>ldata(10), ldata(9)=>ldata(9), ldata(8)=>ldata(8),
      ldata(7)=>ldata(7), ldata(6)=>ldata(6), ldata(5)=>ldata(5),
      ldata(4)=>ldata(4), ldata(3)=>ldata(3), ldata(2)=>ldata(2),
      ldata(1)=>ldata(1), ldata(0)=>ldata(0));

   XLXI_14 : sloclk
      PORT MAP (clkin=>vsync_DUMMY, clkout=>XLXN_79);

   XLXI_29 : slowclkforbutton
      PORT MAP (clkin=>vsync_DUMMY, clkout=>XLXN_80);

   XLXI_2 : top
      PORT MAP (fromvga=>XLXN_79, clk=>bclk, resetn=>resetnn,
      startgame=>startgame, donefrommem=>done_DUMMY, readdone=>readdone,
      button1=>XLXN_75, button2=>XLXN_76, button3=>XLXN_77, button4=>XLXN_83,
      pattern1=>pattern(3), pattern2=>pattern(2), pattern3=>pattern(1),
      pattern4=>pattern(0), readmem=>read, ready=>ready, hit1(1)=>hit0(1),
      hit1(0)=>hit0(0), hit2(1)=>hit1(1), hit2(0)=>hit1(0), hit3(1)=>hit2(1),
      hit3(0)=>hit2(0), hit4(1)=>hit3(1), hit4(0)=>hit3(0),
      rows(119)=>XLXN_63(119), rows(118)=>XLXN_63(118),
      rows(117)=>XLXN_63(117), rows(116)=>XLXN_63(116),
      rows(115)=>XLXN_63(115), rows(114)=>XLXN_63(114),
      rows(113)=>XLXN_63(113), rows(112)=>XLXN_63(112),
      rows(111)=>XLXN_63(111), rows(110)=>XLXN_63(110),
      rows(109)=>XLXN_63(109), rows(108)=>XLXN_63(108),
      rows(107)=>XLXN_63(107), rows(106)=>XLXN_63(106),
      rows(105)=>XLXN_63(105), rows(104)=>XLXN_63(104),
      rows(103)=>XLXN_63(103), rows(102)=>XLXN_63(102),
      rows(101)=>XLXN_63(101), rows(100)=>XLXN_63(100), rows(99)=>XLXN_63(99),
      rows(98)=>XLXN_63(98), rows(97)=>XLXN_63(97), rows(96)=>XLXN_63(96),
      rows(95)=>XLXN_63(95), rows(94)=>XLXN_63(94), rows(93)=>XLXN_63(93),
      rows(92)=>XLXN_63(92), rows(91)=>XLXN_63(91), rows(90)=>XLXN_63(90),
      rows(89)=>XLXN_63(89), rows(88)=>XLXN_63(88), rows(87)=>XLXN_63(87),
      rows(86)=>XLXN_63(86), rows(85)=>XLXN_63(85), rows(84)=>XLXN_63(84),
      rows(83)=>XLXN_63(83), rows(82)=>XLXN_63(82), rows(81)=>XLXN_63(81),
      rows(80)=>XLXN_63(80), rows(79)=>XLXN_63(79), rows(78)=>XLXN_63(78),
      rows(77)=>XLXN_63(77), rows(76)=>XLXN_63(76), rows(75)=>XLXN_63(75),
      rows(74)=>XLXN_63(74), rows(73)=>XLXN_63(73), rows(72)=>XLXN_63(72),
      rows(71)=>XLXN_63(71), rows(70)=>XLXN_63(70), rows(69)=>XLXN_63(69),
      rows(68)=>XLXN_63(68), rows(67)=>XLXN_63(67), rows(66)=>XLXN_63(66),
      rows(65)=>XLXN_63(65), rows(64)=>XLXN_63(64), rows(63)=>XLXN_63(63),
      rows(62)=>XLXN_63(62), rows(61)=>XLXN_63(61), rows(60)=>XLXN_63(60),
      rows(59)=>XLXN_63(59), rows(58)=>XLXN_63(58), rows(57)=>XLXN_63(57),
      rows(56)=>XLXN_63(56), rows(55)=>XLXN_63(55), rows(54)=>XLXN_63(54),
      rows(53)=>XLXN_63(53), rows(52)=>XLXN_63(52), rows(51)=>XLXN_63(51),
      rows(50)=>XLXN_63(50), rows(49)=>XLXN_63(49), rows(48)=>XLXN_63(48),
      rows(47)=>XLXN_63(47), rows(46)=>XLXN_63(46), rows(45)=>XLXN_63(45),
      rows(44)=>XLXN_63(44), rows(43)=>XLXN_63(43), rows(42)=>XLXN_63(42),
      rows(41)=>XLXN_63(41), rows(40)=>XLXN_63(40), rows(39)=>XLXN_63(39),
      rows(38)=>XLXN_63(38), rows(37)=>XLXN_63(37), rows(36)=>XLXN_63(36),
      rows(35)=>XLXN_63(35), rows(34)=>XLXN_63(34), rows(33)=>XLXN_63(33),
      rows(32)=>XLXN_63(32), rows(31)=>XLXN_63(31), rows(30)=>XLXN_63(30),
      rows(29)=>XLXN_63(29), rows(28)=>XLXN_63(28), rows(27)=>XLXN_63(27),
      rows(26)=>XLXN_63(26), rows(25)=>XLXN_63(25), rows(24)=>XLXN_63(24),
      rows(23)=>XLXN_63(23), rows(22)=>XLXN_63(22), rows(21)=>XLXN_63(21),
      rows(20)=>XLXN_63(20), rows(19)=>XLXN_63(19), rows(18)=>XLXN_63(18),
      rows(17)=>XLXN_63(17), rows(16)=>XLXN_63(16), rows(15)=>XLXN_63(15),
      rows(14)=>XLXN_63(14), rows(13)=>XLXN_63(13), rows(12)=>XLXN_63(12),
      rows(11)=>XLXN_63(11), rows(10)=>XLXN_63(10), rows(9)=>XLXN_63(9),
      rows(8)=>XLXN_63(8), rows(7)=>XLXN_63(7), rows(6)=>XLXN_63(6),
      rows(5)=>XLXN_63(5), rows(4)=>XLXN_63(4), rows(3)=>XLXN_63(3),
      rows(2)=>XLXN_63(2), rows(1)=>XLXN_63(1), rows(0)=>XLXN_63(0));

   XLXI_12 : vgatop
      PORT MAP (clk=>bclk, rstn=>resetnn, sdone=>gdone_DUMMY,
      grade(1)=>f_DUMMY(1), grade(0)=>f_DUMMY(0), hit4(1)=>hit3(1),
      hit4(0)=>hit3(0), hit3(1)=>hit2(1), hit3(0)=>hit2(0), hit2(1)=>hit1(1),
      hit2(0)=>hit1(0), hit1(1)=>hit0(1), hit1(0)=>hit0(0),
      inin(119)=>XLXN_63(119), inin(118)=>XLXN_63(118),
      inin(117)=>XLXN_63(117), inin(116)=>XLXN_63(116),
      inin(115)=>XLXN_63(115), inin(114)=>XLXN_63(114),
      inin(113)=>XLXN_63(113), inin(112)=>XLXN_63(112),
      inin(111)=>XLXN_63(111), inin(110)=>XLXN_63(110),
      inin(109)=>XLXN_63(109), inin(108)=>XLXN_63(108),
      inin(107)=>XLXN_63(107), inin(106)=>XLXN_63(106),
      inin(105)=>XLXN_63(105), inin(104)=>XLXN_63(104),
      inin(103)=>XLXN_63(103), inin(102)=>XLXN_63(102),
      inin(101)=>XLXN_63(101), inin(100)=>XLXN_63(100), inin(99)=>XLXN_63(99),
      inin(98)=>XLXN_63(98), inin(97)=>XLXN_63(97), inin(96)=>XLXN_63(96),
      inin(95)=>XLXN_63(95), inin(94)=>XLXN_63(94), inin(93)=>XLXN_63(93),
      inin(92)=>XLXN_63(92), inin(91)=>XLXN_63(91), inin(90)=>XLXN_63(90),
      inin(89)=>XLXN_63(89), inin(88)=>XLXN_63(88), inin(87)=>XLXN_63(87),
      inin(86)=>XLXN_63(86), inin(85)=>XLXN_63(85), inin(84)=>XLXN_63(84),
      inin(83)=>XLXN_63(83), inin(82)=>XLXN_63(82), inin(81)=>XLXN_63(81),
      inin(80)=>XLXN_63(80), inin(79)=>XLXN_63(79), inin(78)=>XLXN_63(78),
      inin(77)=>XLXN_63(77), inin(76)=>XLXN_63(76), inin(75)=>XLXN_63(75),
      inin(74)=>XLXN_63(74), inin(73)=>XLXN_63(73), inin(72)=>XLXN_63(72),
      inin(71)=>XLXN_63(71), inin(70)=>XLXN_63(70), inin(69)=>XLXN_63(69),
      inin(68)=>XLXN_63(68), inin(67)=>XLXN_63(67), inin(66)=>XLXN_63(66),
      inin(65)=>XLXN_63(65), inin(64)=>XLXN_63(64), inin(63)=>XLXN_63(63),
      inin(62)=>XLXN_63(62), inin(61)=>XLXN_63(61), inin(60)=>XLXN_63(60),
      inin(59)=>XLXN_63(59), inin(58)=>XLXN_63(58), inin(57)=>XLXN_63(57),
      inin(56)=>XLXN_63(56), inin(55)=>XLXN_63(55), inin(54)=>XLXN_63(54),
      inin(53)=>XLXN_63(53), inin(52)=>XLXN_63(52), inin(51)=>XLXN_63(51),
      inin(50)=>XLXN_63(50), inin(49)=>XLXN_63(49), inin(48)=>XLXN_63(48),
      inin(47)=>XLXN_63(47), inin(46)=>XLXN_63(46), inin(45)=>XLXN_63(45),
      inin(44)=>XLXN_63(44), inin(43)=>XLXN_63(43), inin(42)=>XLXN_63(42),
      inin(41)=>XLXN_63(41), inin(40)=>XLXN_63(40), inin(39)=>XLXN_63(39),
      inin(38)=>XLXN_63(38), inin(37)=>XLXN_63(37), inin(36)=>XLXN_63(36),
      inin(35)=>XLXN_63(35), inin(34)=>XLXN_63(34), inin(33)=>XLXN_63(33),
      inin(32)=>XLXN_63(32), inin(31)=>XLXN_63(31), inin(30)=>XLXN_63(30),
      inin(29)=>XLXN_63(29), inin(28)=>XLXN_63(28), inin(27)=>XLXN_63(27),
      inin(26)=>XLXN_63(26), inin(25)=>XLXN_63(25), inin(24)=>XLXN_63(24),
      inin(23)=>XLXN_63(23), inin(22)=>XLXN_63(22), inin(21)=>XLXN_63(21),
      inin(20)=>XLXN_63(20), inin(19)=>XLXN_63(19), inin(18)=>XLXN_63(18),
      inin(17)=>XLXN_63(17), inin(16)=>XLXN_63(16), inin(15)=>XLXN_63(15),
      inin(14)=>XLXN_63(14), inin(13)=>XLXN_63(13), inin(12)=>XLXN_63(12),
      inin(11)=>XLXN_63(11), inin(10)=>XLXN_63(10), inin(9)=>XLXN_63(9),
      inin(8)=>XLXN_63(8), inin(7)=>XLXN_63(7), inin(6)=>XLXN_63(6),
      inin(5)=>XLXN_63(5), inin(4)=>XLXN_63(4), inin(3)=>XLXN_63(3),
      inin(2)=>XLXN_63(2), inin(1)=>XLXN_63(1), inin(0)=>XLXN_63(0),
      blankn=>blankn, pixel(7)=>pixel(7), pixel(6)=>pixel(6),
      pixel(5)=>pixel(5), pixel(4)=>pixel(4), pixel(3)=>pixel(3),
      pixel(2)=>pixel(2), pixel(1)=>pixel(1), pixel(0)=>pixel(0),
      rramce=>rramce, triste=>triste, vsync=>vsync_DUMMY, hsync=>hsync,
      WRn=>WRn, RDn=>RDn, pixelclk=>pixelclk, RAMDACD(7)=>RAMDACD(7),
      RAMDACD(6)=>RAMDACD(6), RAMDACD(5)=>RAMDACD(5), RAMDACD(4)=>RAMDACD(4),
      RAMDACD(3)=>RAMDACD(3), RAMDACD(2)=>RAMDACD(2), RAMDACD(1)=>RAMDACD(1),
      RAMDACD(0)=>RAMDACD(0), RS(2)=>RS(2), RS(1)=>RS(1), RS(0)=>RS(0));

END SCHEMATIC;



