-- Vhdl model created from schematic memin.sch - Sun Mar 14 16:07:56 2004

LIBRARY ieee;
LIBRARY UNISIM;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
USE UNISIM.Vcomponents.ALL;

ENTITY memin IS
   PORT ( IssueRead	:	IN	STD_LOGIC; 
          clk	:	IN	STD_LOGIC; 
          ppdata	:	IN	STD_LOGIC_VECTOR (7 DOWNTO 0); 
          resetn	:	IN	STD_LOGIC; 
          startaddr	:	IN	STD_LOGIC_VECTOR (18 DOWNTO 0); 
          stopaddr	:	IN	STD_LOGIC_VECTOR (18 DOWNTO 0); 
          done	:	OUT	STD_LOGIC; 
          laddr	:	OUT	STD_LOGIC_VECTOR (18 DOWNTO 0); 
          lcen	:	OUT	STD_LOGIC; 
          loen	:	OUT	STD_LOGIC; 
          lwen	:	OUT	STD_LOGIC; 
          outdata	:	OUT	STD_LOGIC_VECTOR (3 DOWNTO 0); 
          ppstatus	:	OUT	STD_LOGIC_VECTOR (6 DOWNTO 3); 
          readdone	:	OUT	STD_LOGIC; 
          ldata	:	INOUT	STD_LOGIC_VECTOR (15 DOWNTO 0));

end memin;

ARCHITECTURE SCHEMATIC OF memin IS
   SIGNAL XLXN_28	:	STD_LOGIC_VECTOR (15 DOWNTO 0);
   SIGNAL XLXN_32	:	STD_LOGIC;
   SIGNAL XLXN_44	:	STD_LOGIC_VECTOR (18 DOWNTO 0);
   SIGNAL XLXN_45	:	STD_LOGIC_VECTOR (15 DOWNTO 0);
   SIGNAL XLXN_46	:	STD_LOGIC;
   SIGNAL canread	:	STD_LOGIC;
   SIGNAL continue	:	STD_LOGIC;
   SIGNAL count	:	STD_LOGIC_VECTOR (1 DOWNTO 0);
   SIGNAL dline	:	STD_LOGIC;
   SIGNAL readAddr	:	STD_LOGIC_VECTOR (18 DOWNTO 0);

   ATTRIBUTE fpga_dont_touch : STRING ;

   COMPONENT fbit1time
      PORT ( continue	:	IN	STD_LOGIC; 
             resetn	:	IN	STD_LOGIC; 
             CLK	:	IN	STD_LOGIC; 
             stopaddr	:	IN	STD_LOGIC_VECTOR (18 DOWNTO 0); 
             startaddr	:	IN	STD_LOGIC_VECTOR (18 DOWNTO 0); 
             done	:	OUT	STD_LOGIC; 
             count	:	OUT	STD_LOGIC_VECTOR (1 DOWNTO 0); 
             ReadAddr	:	OUT	STD_LOGIC_VECTOR (18 DOWNTO 0));
   END COMPONENT;

   COMPONENT memread
      PORT ( CLK	:	IN	STD_LOGIC; 
             cr	:	IN	STD_LOGIC; 
             done	:	IN	STD_LOGIC; 
             IssueRead	:	IN	STD_LOGIC; 
             resetn	:	IN	STD_LOGIC; 
             continue	:	OUT	STD_LOGIC; 
             dr	:	OUT	STD_LOGIC; 
             finished	:	OUT	STD_LOGIC; 
             rdone	:	OUT	STD_LOGIC);
   END COMPONENT;

   COMPONENT out4bit
      PORT ( count	:	IN	STD_LOGIC_VECTOR (1 DOWNTO 0); 
             datain	:	IN	STD_LOGIC_VECTOR (15 DOWNTO 0); 
             outdata	:	OUT	STD_LOGIC_VECTOR (3 DOWNTO 0));
   END COMPONENT;

   COMPONENT sraminterfacewithpport
      PORT ( CLK	:	IN	STD_LOGIC; 
             Resetn	:	IN	STD_LOGIC; 
             doRead	:	IN	STD_LOGIC; 
             doWrite	:	IN	STD_LOGIC; 
             readAddr	:	IN	STD_LOGIC_VECTOR (18 DOWNTO 0); 
             writeAddr	:	IN	STD_LOGIC_VECTOR (18 DOWNTO 0); 
             writeData	:	IN	STD_LOGIC_VECTOR (15 DOWNTO 0); 
             ppdata	:	IN	STD_LOGIC_VECTOR (7 DOWNTO 0); 
             canRead	:	OUT	STD_LOGIC; 
             canWrite	:	OUT	STD_LOGIC; 
             CELeftn	:	OUT	STD_LOGIC; 
             OELeftn	:	OUT	STD_LOGIC; 
             WELeftn	:	OUT	STD_LOGIC; 
             readData	:	OUT	STD_LOGIC_VECTOR (15 DOWNTO 0); 
             SRAMLeftAddr	:	OUT	STD_LOGIC_VECTOR (18 DOWNTO 0); 
             ppstatus	:	OUT	STD_LOGIC_VECTOR (6 DOWNTO 3); 
             SRAMLeftData	:	INOUT	STD_LOGIC_VECTOR (15 DOWNTO 0));
   END COMPONENT;

   COMPONENT zeros
      PORT ( Wdone	:	OUT	STD_LOGIC; 
             Waddr	:	OUT	STD_LOGIC_VECTOR (18 DOWNTO 0); 
             Wdata	:	OUT	STD_LOGIC_VECTOR (15 DOWNTO 0));
   END COMPONENT;

BEGIN

   XLXI_1 : fbit1time
      PORT MAP (continue=>continue, resetn=>resetn, CLK=>clk,
      stopaddr(18)=>stopaddr(18), stopaddr(17)=>stopaddr(17),
      stopaddr(16)=>stopaddr(16), stopaddr(15)=>stopaddr(15),
      stopaddr(14)=>stopaddr(14), stopaddr(13)=>stopaddr(13),
      stopaddr(12)=>stopaddr(12), stopaddr(11)=>stopaddr(11),
      stopaddr(10)=>stopaddr(10), stopaddr(9)=>stopaddr(9),
      stopaddr(8)=>stopaddr(8), stopaddr(7)=>stopaddr(7),
      stopaddr(6)=>stopaddr(6), stopaddr(5)=>stopaddr(5),
      stopaddr(4)=>stopaddr(4), stopaddr(3)=>stopaddr(3),
      stopaddr(2)=>stopaddr(2), stopaddr(1)=>stopaddr(1),
      stopaddr(0)=>stopaddr(0), startaddr(18)=>startaddr(18),
      startaddr(17)=>startaddr(17), startaddr(16)=>startaddr(16),
      startaddr(15)=>startaddr(15), startaddr(14)=>startaddr(14),
      startaddr(13)=>startaddr(13), startaddr(12)=>startaddr(12),
      startaddr(11)=>startaddr(11), startaddr(10)=>startaddr(10),
      startaddr(9)=>startaddr(9), startaddr(8)=>startaddr(8),
      startaddr(7)=>startaddr(7), startaddr(6)=>startaddr(6),
      startaddr(5)=>startaddr(5), startaddr(4)=>startaddr(4),
      startaddr(3)=>startaddr(3), startaddr(2)=>startaddr(2),
      startaddr(1)=>startaddr(1), startaddr(0)=>startaddr(0), done=>dline,
      count(1)=>count(1), count(0)=>count(0), ReadAddr(18)=>readAddr(18),
      ReadAddr(17)=>readAddr(17), ReadAddr(16)=>readAddr(16),
      ReadAddr(15)=>readAddr(15), ReadAddr(14)=>readAddr(14),
      ReadAddr(13)=>readAddr(13), ReadAddr(12)=>readAddr(12),
      ReadAddr(11)=>readAddr(11), ReadAddr(10)=>readAddr(10),
      ReadAddr(9)=>readAddr(9), ReadAddr(8)=>readAddr(8),
      ReadAddr(7)=>readAddr(7), ReadAddr(6)=>readAddr(6),
      ReadAddr(5)=>readAddr(5), ReadAddr(4)=>readAddr(4),
      ReadAddr(3)=>readAddr(3), ReadAddr(2)=>readAddr(2),
      ReadAddr(1)=>readAddr(1), ReadAddr(0)=>readAddr(0));

   XLXI_4 : memread
      PORT MAP (CLK=>clk, cr=>canread, done=>dline, IssueRead=>IssueRead,
      resetn=>resetn, continue=>continue, dr=>XLXN_32, finished=>done,
      rdone=>readdone);

   XLXI_5 : out4bit
      PORT MAP (count(1)=>count(1), count(0)=>count(0),
      datain(15)=>XLXN_28(15), datain(14)=>XLXN_28(14),
      datain(13)=>XLXN_28(13), datain(12)=>XLXN_28(12),
      datain(11)=>XLXN_28(11), datain(10)=>XLXN_28(10), datain(9)=>XLXN_28(9),
      datain(8)=>XLXN_28(8), datain(7)=>XLXN_28(7), datain(6)=>XLXN_28(6),
      datain(5)=>XLXN_28(5), datain(4)=>XLXN_28(4), datain(3)=>XLXN_28(3),
      datain(2)=>XLXN_28(2), datain(1)=>XLXN_28(1), datain(0)=>XLXN_28(0),
      outdata(3)=>outdata(3), outdata(2)=>outdata(2), outdata(1)=>outdata(1),
      outdata(0)=>outdata(0));

   XLXI_3 : sraminterfacewithpport
      PORT MAP (CLK=>clk, Resetn=>resetn, doRead=>XLXN_32, doWrite=>XLXN_46,
      readAddr(18)=>readAddr(18), readAddr(17)=>readAddr(17),
      readAddr(16)=>readAddr(16), readAddr(15)=>readAddr(15),
      readAddr(14)=>readAddr(14), readAddr(13)=>readAddr(13),
      readAddr(12)=>readAddr(12), readAddr(11)=>readAddr(11),
      readAddr(10)=>readAddr(10), readAddr(9)=>readAddr(9),
      readAddr(8)=>readAddr(8), readAddr(7)=>readAddr(7),
      readAddr(6)=>readAddr(6), readAddr(5)=>readAddr(5),
      readAddr(4)=>readAddr(4), readAddr(3)=>readAddr(3),
      readAddr(2)=>readAddr(2), readAddr(1)=>readAddr(1),
      readAddr(0)=>readAddr(0), writeAddr(18)=>XLXN_44(18),
      writeAddr(17)=>XLXN_44(17), writeAddr(16)=>XLXN_44(16),
      writeAddr(15)=>XLXN_44(15), writeAddr(14)=>XLXN_44(14),
      writeAddr(13)=>XLXN_44(13), writeAddr(12)=>XLXN_44(12),
      writeAddr(11)=>XLXN_44(11), writeAddr(10)=>XLXN_44(10),
      writeAddr(9)=>XLXN_44(9), writeAddr(8)=>XLXN_44(8),
      writeAddr(7)=>XLXN_44(7), writeAddr(6)=>XLXN_44(6),
      writeAddr(5)=>XLXN_44(5), writeAddr(4)=>XLXN_44(4),
      writeAddr(3)=>XLXN_44(3), writeAddr(2)=>XLXN_44(2),
      writeAddr(1)=>XLXN_44(1), writeAddr(0)=>XLXN_44(0),
      writeData(15)=>XLXN_45(15), writeData(14)=>XLXN_45(14),
      writeData(13)=>XLXN_45(13), writeData(12)=>XLXN_45(12),
      writeData(11)=>XLXN_45(11), writeData(10)=>XLXN_45(10),
      writeData(9)=>XLXN_45(9), writeData(8)=>XLXN_45(8),
      writeData(7)=>XLXN_45(7), writeData(6)=>XLXN_45(6),
      writeData(5)=>XLXN_45(5), writeData(4)=>XLXN_45(4),
      writeData(3)=>XLXN_45(3), writeData(2)=>XLXN_45(2),
      writeData(1)=>XLXN_45(1), writeData(0)=>XLXN_45(0), ppdata(7)=>ppdata(7),
      ppdata(6)=>ppdata(6), ppdata(5)=>ppdata(5), ppdata(4)=>ppdata(4),
      ppdata(3)=>ppdata(3), ppdata(2)=>ppdata(2), ppdata(1)=>ppdata(1),
      ppdata(0)=>ppdata(0), canRead=>canread, canWrite=>open, CELeftn=>lcen,
      OELeftn=>loen, WELeftn=>lwen, readData(15)=>XLXN_28(15),
      readData(14)=>XLXN_28(14), readData(13)=>XLXN_28(13),
      readData(12)=>XLXN_28(12), readData(11)=>XLXN_28(11),
      readData(10)=>XLXN_28(10), readData(9)=>XLXN_28(9),
      readData(8)=>XLXN_28(8), readData(7)=>XLXN_28(7),
      readData(6)=>XLXN_28(6), readData(5)=>XLXN_28(5),
      readData(4)=>XLXN_28(4), readData(3)=>XLXN_28(3),
      readData(2)=>XLXN_28(2), readData(1)=>XLXN_28(1),
      readData(0)=>XLXN_28(0), SRAMLeftAddr(18)=>laddr(18),
      SRAMLeftAddr(17)=>laddr(17), SRAMLeftAddr(16)=>laddr(16),
      SRAMLeftAddr(15)=>laddr(15), SRAMLeftAddr(14)=>laddr(14),
      SRAMLeftAddr(13)=>laddr(13), SRAMLeftAddr(12)=>laddr(12),
      SRAMLeftAddr(11)=>laddr(11), SRAMLeftAddr(10)=>laddr(10),
      SRAMLeftAddr(9)=>laddr(9), SRAMLeftAddr(8)=>laddr(8),
      SRAMLeftAddr(7)=>laddr(7), SRAMLeftAddr(6)=>laddr(6),
      SRAMLeftAddr(5)=>laddr(5), SRAMLeftAddr(4)=>laddr(4),
      SRAMLeftAddr(3)=>laddr(3), SRAMLeftAddr(2)=>laddr(2),
      SRAMLeftAddr(1)=>laddr(1), SRAMLeftAddr(0)=>laddr(0),
      ppstatus(6)=>ppstatus(6), ppstatus(5)=>ppstatus(5),
      ppstatus(4)=>ppstatus(4), ppstatus(3)=>ppstatus(3),
      SRAMLeftData(15)=>ldata(15), SRAMLeftData(14)=>ldata(14),
      SRAMLeftData(13)=>ldata(13), SRAMLeftData(12)=>ldata(12),
      SRAMLeftData(11)=>ldata(11), SRAMLeftData(10)=>ldata(10),
      SRAMLeftData(9)=>ldata(9), SRAMLeftData(8)=>ldata(8),
      SRAMLeftData(7)=>ldata(7), SRAMLeftData(6)=>ldata(6),
      SRAMLeftData(5)=>ldata(5), SRAMLeftData(4)=>ldata(4),
      SRAMLeftData(3)=>ldata(3), SRAMLeftData(2)=>ldata(2),
      SRAMLeftData(1)=>ldata(1), SRAMLeftData(0)=>ldata(0));

   XLXI_6 : zeros
      PORT MAP (Wdone=>XLXN_46, Waddr(18)=>XLXN_44(18), Waddr(17)=>XLXN_44(17),
      Waddr(16)=>XLXN_44(16), Waddr(15)=>XLXN_44(15), Waddr(14)=>XLXN_44(14),
      Waddr(13)=>XLXN_44(13), Waddr(12)=>XLXN_44(12), Waddr(11)=>XLXN_44(11),
      Waddr(10)=>XLXN_44(10), Waddr(9)=>XLXN_44(9), Waddr(8)=>XLXN_44(8),
      Waddr(7)=>XLXN_44(7), Waddr(6)=>XLXN_44(6), Waddr(5)=>XLXN_44(5),
      Waddr(4)=>XLXN_44(4), Waddr(3)=>XLXN_44(3), Waddr(2)=>XLXN_44(2),
      Waddr(1)=>XLXN_44(1), Waddr(0)=>XLXN_44(0), Wdata(15)=>XLXN_45(15),
      Wdata(14)=>XLXN_45(14), Wdata(13)=>XLXN_45(13), Wdata(12)=>XLXN_45(12),
      Wdata(11)=>XLXN_45(11), Wdata(10)=>XLXN_45(10), Wdata(9)=>XLXN_45(9),
      Wdata(8)=>XLXN_45(8), Wdata(7)=>XLXN_45(7), Wdata(6)=>XLXN_45(6),
      Wdata(5)=>XLXN_45(5), Wdata(4)=>XLXN_45(4), Wdata(3)=>XLXN_45(3),
      Wdata(2)=>XLXN_45(2), Wdata(1)=>XLXN_45(1), Wdata(0)=>XLXN_45(0));

END SCHEMATIC;



