library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity top is
    Port ( fromvga : in std_logic;                                     --from vga
           clk : in std_logic;
           resetn : in std_logic;
			  startgame: in std_logic;
				donefrommem : in std_logic;
				readmem : out std_logic;
           readdone: in std_logic;
           ready: out std_logic;
           button1,button2,button3,button4 : in std_logic;
           hit1,hit2,hit3,hit4 : out std_logic_vector(1 downto 0);
-----------------------------------
--pattern from memory
           pattern1, pattern2, pattern3, pattern4: in std_logic;
-----------------------------------
--to vga
--           row1,row2,row3,row4,row5,row6,row7,row8,row9,row10,
--           row11,row12,row13,row14,row15,row16,row17,row18,row19,row20,                                    
--           row21,row22,row23,row24,row25,row26,row27,row28,row29,row30,
--           row31,row32,row33,row34,row35,row36,row37,row38,row39,row40,
--           row41,row42,row43,row44,row45,row46,row47,row48,row49,row50 : out std_logic_vector(3 downto 0)
			  rows : out std_logic_vector (119 downto 0)
-------------------------------
           );
end top;

architecture Behavioral of top is

	COMPONENT shift50b
	PORT(
		doshift : IN std_logic;
		resetn : IN std_logic;
		patternin : IN std_logic;          
		patternout : OUT std_logic_vector(29 downto 0)
		);
	END COMPONENT;

	
	COMPONENT hit
	PORT(
		resetn : IN std_logic;
	--	vsync : IN std_logic;
		button1 : IN std_logic;
		button2 : IN std_logic;
		button3 : IN std_logic;
		button4 : IN std_logic;
		bottom1 : IN std_logic;
		bottom2 : IN std_logic;
		bottom3 : IN std_logic;
		bottom4 : IN std_logic;          
		hit1 : OUT std_logic_vector(1 downto 0);
		hit2 : OUT std_logic_vector(1 downto 0);
		hit3 : OUT std_logic_vector(1 downto 0);
		hit4 : OUT std_logic_vector(1 downto 0)
		);
	END COMPONENT;

	COMPONENT shifctrl
	PORT(
		CLK : IN std_logic;
		done : IN std_logic;
		fromvga : IN std_logic;
		readdone : IN std_logic;
		resetL : IN std_logic;
		startgame : IN std_logic;          
		readmem : OUT std_logic;
		ready : OUT std_logic;
		resetn : OUT std_logic;
		shift : OUT std_logic
		);
	END COMPONENT;

-----------------------------------
--buses and signal
    signal col1 : std_logic_vector (29 downto 0);
    signal col2 : std_logic_vector (29 downto 0);
    signal col3 : std_logic_vector (29 downto 0);
    signal col4 : std_logic_vector (29 downto 0);
	 signal resets	: std_logic;
	 signal shifts	: std_logic;
-----------------------------------    
    
begin
			Inst_shifctrl: shifctrl PORT MAP(
				CLK => clk,
				done => donefrommem,
				fromvga => fromvga,
				readdone => readdone,
				resetL => resetn,
				startgame => startgame,
				readmem => readmem,
				ready => ready,
				resetn => resets,
				shift => shifts
			);
        Inst_shift50b1: shift50b PORT MAP(
        		doshift => shifts,
        		resetn => resets ,
        		patternin => pattern1,
        		patternout => col1
        );
        Inst_shift50b2: shift50b PORT MAP(
        		doshift => shifts,
        		resetn => resets ,
        		patternin => pattern2,
        		patternout => col2
        );
        Inst_shift50b3: shift50b PORT MAP(
        		doshift => shifts,
        		resetn => resets ,
        		patternin => pattern3,
        		patternout => col3
        );
        Inst_shift50b4: shift50b PORT MAP(
        		doshift => shifts,
        		resetn => resets ,
        		patternin => pattern4,
        		patternout => col4
        );
		  Inst_hit: hit PORT MAP(
				resetn => resetn,
	--			vsync => fromvga,
				button1 => button1,
				button2 => button2,
				button3 => button3,
				button4 => button4,
				bottom1 => col1(0),
				bottom2 => col2(0),
				bottom3 => col3(0),
				bottom4 => col4(0),
				hit1 => hit1,
				hit2 => hit2,
				hit3 => hit3,
				hit4 => hit4
			);

         
         rows(119 downto 0) <=  	col1(29) & col2(29) & col3(29) & col4(29)
		   							& col1(28) & col2(28) & col3(28) & col4(28)
		   							& col1(27) & col2(27) & col3(27) & col4(27)
    								& col1(26) & col2(26) & col3(26) & col4(26)
 									& col1(25) & col2(25) & col3(25) & col4(25)
									& col1(24) & col2(24) & col3(24) & col4(24)
         							& col1(23) & col2(23) & col3(23) & col4(23)
         							& col1(22) & col2(22) & col3(22) & col4(22)
         							& col1(21) & col2(21) & col3(21) & col4(21)
         							& col1(20) & col2(20) & col3(20) & col4(20)
         							& col1(19) & col2(19) & col3(19) & col4(19)
         							& col1(18) & col2(18) & col3(18) & col4(18)
         							& col1(17) & col2(17) & col3(17) & col4(17)
         							& col1(16) & col2(16) & col3(16) & col4(16)
         							& col1(15) & col2(15) & col3(15) & col4(15)
         							& col1(14) & col2(14) & col3(14) & col4(14)
        							& col1(13) & col2(13) & col3(13) & col4(13)
         							& col1(12) & col2(12) & col3(12) & col4(12)
         							& col1(11) & col2(11) & col3(11) & col4(11)
         							& col1(10) & col2(10) & col3(10) & col4(10)
									& col1(9) & col2(9) & col3(9) & col4(9)
         							& col1(8) & col2(8) & col3(8) & col4(8)
         							& col1(7) & col2(7) & col3(7) & col4(7)
         							& col1(6) & col2(6) & col3(6) & col4(6)
         							& col1(5) & col2(5) & col3(5) & col4(5)
         							& col1(4) & col2(4) & col3(4) & col4(4)
        							& col1(3) & col2(3) & col3(3) & col4(3)
         							& col1(2) & col2(2) & col3(2) & col4(2)
         							& col1(1) & col2(1) & col3(1) & col4(1)
         							& col1(0) & col2(0) & col3(0) & col4(0);
         
         

   
end Behavioral;
