-- Vhdl model created from schematic vgatop.sch - Mon Mar 22 06:58:52 2004

LIBRARY ieee;
LIBRARY UNISIM;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
USE UNISIM.Vcomponents.ALL;

ENTITY vgatop IS
   PORT ( clk	:	IN	STD_LOGIC; 
          grade	:	IN	STD_LOGIC_VECTOR (1 DOWNTO 0); 
          hit1	:	IN	STD_LOGIC_VECTOR (1 DOWNTO 0); 
          hit2	:	IN	STD_LOGIC_VECTOR (1 DOWNTO 0); 
          hit3	:	IN	STD_LOGIC_VECTOR (1 DOWNTO 0); 
          hit4	:	IN	STD_LOGIC_VECTOR (1 DOWNTO 0); 
          inin	:	IN	STD_LOGIC_VECTOR (119 DOWNTO 0); 
          rstn	:	IN	STD_LOGIC; 
          sdone	:	IN	STD_LOGIC; 
          RAMDACD	:	OUT	STD_LOGIC_VECTOR (7 DOWNTO 0); 
          RDn	:	OUT	STD_LOGIC; 
          RS	:	OUT	STD_LOGIC_VECTOR (2 DOWNTO 0); 
          WRn	:	OUT	STD_LOGIC; 
          blankn	:	OUT	STD_LOGIC; 
          hsync	:	OUT	STD_LOGIC; 
          pixel	:	OUT	STD_LOGIC_VECTOR (7 DOWNTO 0); 
          pixelclk	:	OUT	STD_LOGIC; 
          rramce	:	OUT	STD_LOGIC; 
          triste	:	OUT	STD_LOGIC; 
          vsync	:	OUT	STD_LOGIC);

end vgatop;

ARCHITECTURE SCHEMATIC OF vgatop IS
   SIGNAL RAMDACD_DUMMY	:	STD_LOGIC_VECTOR (7 DOWNTO 0);
   SIGNAL RS_DUMMY	:	STD_LOGIC_VECTOR (2 DOWNTO 0);

   ATTRIBUTE fpga_dont_touch : STRING ;

   COMPONENT vga
      PORT ( clk	:	IN	STD_LOGIC; 
             rstn	:	IN	STD_LOGIC; 
             sdone	:	IN	STD_LOGIC; 
             hit0	:	IN	STD_LOGIC_VECTOR (1 DOWNTO 0); 
             hit1	:	IN	STD_LOGIC_VECTOR (1 DOWNTO 0); 
             hit2	:	IN	STD_LOGIC_VECTOR (1 DOWNTO 0); 
             hit3	:	IN	STD_LOGIC_VECTOR (1 DOWNTO 0); 
             wholelist	:	IN	STD_LOGIC_VECTOR (119 DOWNTO 0); 
             grade	:	IN	STD_LOGIC_VECTOR (1 DOWNTO 0); 
             blankn	:	OUT	STD_LOGIC; 
             RDn	:	OUT	STD_LOGIC; 
             WRn	:	OUT	STD_LOGIC; 
             hsync	:	OUT	STD_LOGIC; 
             vsync	:	OUT	STD_LOGIC; 
             triste	:	OUT	STD_LOGIC; 
             rramce	:	OUT	STD_LOGIC; 
             pixelclk	:	OUT	STD_LOGIC; 
             pixel	:	OUT	STD_LOGIC_VECTOR (7 DOWNTO 0); 
             RAMDACD	:	INOUT	STD_LOGIC_VECTOR (7 DOWNTO 0); 
             RS	:	INOUT	STD_LOGIC_VECTOR (2 DOWNTO 0));
   END COMPONENT;

BEGIN
   RAMDACD <= RAMDACD_DUMMY;
   RS <= RS_DUMMY;

   XLXI_1 : vga
      PORT MAP (clk=>clk, rstn=>rstn, sdone=>sdone, hit0(1)=>hit4(1),
      hit0(0)=>hit4(0), hit1(1)=>hit3(1), hit1(0)=>hit3(0), hit2(1)=>hit2(1),
      hit2(0)=>hit2(0), hit3(1)=>hit1(1), hit3(0)=>hit1(0),
      wholelist(119)=>inin(119), wholelist(118)=>inin(118),
      wholelist(117)=>inin(117), wholelist(116)=>inin(116),
      wholelist(115)=>inin(115), wholelist(114)=>inin(114),
      wholelist(113)=>inin(113), wholelist(112)=>inin(112),
      wholelist(111)=>inin(111), wholelist(110)=>inin(110),
      wholelist(109)=>inin(109), wholelist(108)=>inin(108),
      wholelist(107)=>inin(107), wholelist(106)=>inin(106),
      wholelist(105)=>inin(105), wholelist(104)=>inin(104),
      wholelist(103)=>inin(103), wholelist(102)=>inin(102),
      wholelist(101)=>inin(101), wholelist(100)=>inin(100),
      wholelist(99)=>inin(99), wholelist(98)=>inin(98),
      wholelist(97)=>inin(97), wholelist(96)=>inin(96),
      wholelist(95)=>inin(95), wholelist(94)=>inin(94),
      wholelist(93)=>inin(93), wholelist(92)=>inin(92),
      wholelist(91)=>inin(91), wholelist(90)=>inin(90),
      wholelist(89)=>inin(89), wholelist(88)=>inin(88),
      wholelist(87)=>inin(87), wholelist(86)=>inin(86),
      wholelist(85)=>inin(85), wholelist(84)=>inin(84),
      wholelist(83)=>inin(83), wholelist(82)=>inin(82),
      wholelist(81)=>inin(81), wholelist(80)=>inin(80),
      wholelist(79)=>inin(79), wholelist(78)=>inin(78),
      wholelist(77)=>inin(77), wholelist(76)=>inin(76),
      wholelist(75)=>inin(75), wholelist(74)=>inin(74),
      wholelist(73)=>inin(73), wholelist(72)=>inin(72),
      wholelist(71)=>inin(71), wholelist(70)=>inin(70),
      wholelist(69)=>inin(69), wholelist(68)=>inin(68),
      wholelist(67)=>inin(67), wholelist(66)=>inin(66),
      wholelist(65)=>inin(65), wholelist(64)=>inin(64),
      wholelist(63)=>inin(63), wholelist(62)=>inin(62),
      wholelist(61)=>inin(61), wholelist(60)=>inin(60),
      wholelist(59)=>inin(59), wholelist(58)=>inin(58),
      wholelist(57)=>inin(57), wholelist(56)=>inin(56),
      wholelist(55)=>inin(55), wholelist(54)=>inin(54),
      wholelist(53)=>inin(53), wholelist(52)=>inin(52),
      wholelist(51)=>inin(51), wholelist(50)=>inin(50),
      wholelist(49)=>inin(49), wholelist(48)=>inin(48),
      wholelist(47)=>inin(47), wholelist(46)=>inin(46),
      wholelist(45)=>inin(45), wholelist(44)=>inin(44),
      wholelist(43)=>inin(43), wholelist(42)=>inin(42),
      wholelist(41)=>inin(41), wholelist(40)=>inin(40),
      wholelist(39)=>inin(39), wholelist(38)=>inin(38),
      wholelist(37)=>inin(37), wholelist(36)=>inin(36),
      wholelist(35)=>inin(35), wholelist(34)=>inin(34),
      wholelist(33)=>inin(33), wholelist(32)=>inin(32),
      wholelist(31)=>inin(31), wholelist(30)=>inin(30),
      wholelist(29)=>inin(29), wholelist(28)=>inin(28),
      wholelist(27)=>inin(27), wholelist(26)=>inin(26),
      wholelist(25)=>inin(25), wholelist(24)=>inin(24),
      wholelist(23)=>inin(23), wholelist(22)=>inin(22),
      wholelist(21)=>inin(21), wholelist(20)=>inin(20),
      wholelist(19)=>inin(19), wholelist(18)=>inin(18),
      wholelist(17)=>inin(17), wholelist(16)=>inin(16),
      wholelist(15)=>inin(15), wholelist(14)=>inin(14),
      wholelist(13)=>inin(13), wholelist(12)=>inin(12),
      wholelist(11)=>inin(11), wholelist(10)=>inin(10), wholelist(9)=>inin(9),
      wholelist(8)=>inin(8), wholelist(7)=>inin(7), wholelist(6)=>inin(6),
      wholelist(5)=>inin(5), wholelist(4)=>inin(4), wholelist(3)=>inin(3),
      wholelist(2)=>inin(2), wholelist(1)=>inin(1), wholelist(0)=>inin(0),
      grade(1)=>grade(1), grade(0)=>grade(0), blankn=>blankn, RDn=>RDn,
      WRn=>WRn, hsync=>hsync, vsync=>vsync, triste=>triste, rramce=>rramce,
      pixelclk=>pixelclk, pixel(7)=>pixel(7), pixel(6)=>pixel(6),
      pixel(5)=>pixel(5), pixel(4)=>pixel(4), pixel(3)=>pixel(3),
      pixel(2)=>pixel(2), pixel(1)=>pixel(1), pixel(0)=>pixel(0),
      RAMDACD(7)=>RAMDACD_DUMMY(7), RAMDACD(6)=>RAMDACD_DUMMY(6),
      RAMDACD(5)=>RAMDACD_DUMMY(5), RAMDACD(4)=>RAMDACD_DUMMY(4),
      RAMDACD(3)=>RAMDACD_DUMMY(3), RAMDACD(2)=>RAMDACD_DUMMY(2),
      RAMDACD(1)=>RAMDACD_DUMMY(1), RAMDACD(0)=>RAMDACD_DUMMY(0),
      RS(2)=>RS_DUMMY(2), RS(1)=>RS_DUMMY(1), RS(0)=>RS_DUMMY(0));

END SCHEMATIC;



